package grafos;

import java.awt.*;
import java.awt.event.*;
import javax.swing.border.*;
import javax.swing.*;



class AreaDesenho extends JPanel {

  Grafo grafo = null;
  No no_sel;
  int larguraAreaDesenho;
  int alturaAreaDesenho;
  JPanel jPanel1 = new JPanel();
  private Image mImage;

  // construtor
  public AreaDesenho(Grafo g, int l, int a) {
    grafo = g;
    larguraAreaDesenho = l;
    alturaAreaDesenho = a;
    setPreferredSize(new Dimension(larguraAreaDesenho, alturaAreaDesenho));
    this.setBorder(BorderFactory.createEtchedBorder());
    this.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        Grafo_mouseClicked(e);
      }
    });
    this.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        Grafo_mousePressed(e);
      }
    });
    this.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseReleased(MouseEvent e) {
        Grafo_mouseReleased(e);
      }
    });
    this.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
      public void mouseDragged(MouseEvent e) {
        Grafo_mouseDragged(e);
      }
    });
  }

  // redefinir metodo paint para podermos desenhar o Grafo
  public void paintOffscreen(Graphics grafico) {
    super.paint(grafico);
    // Manda desenhar o grafo...
    grafo.desenharGrafo(grafico);
  }

  // tecnica de duplo buffer para animao
  public void paint(Graphics g) {
    Dimension d = getSize();
    checkOffscreenImage();
    Graphics offG = mImage.getGraphics();
    offG.setColor(getBackground());
    offG.fillRect(0, 0, d.width, d.height);
    paintOffscreen(mImage.getGraphics());
    g.drawImage(mImage, 0, 0, null);
  }

  private void checkOffscreenImage() {
    Dimension d = getSize();
    if (mImage == null ||
        mImage.getWidth(null) != d.width ||
        mImage.getHeight(null) != d.height) {
      mImage = createImage(d.width, d.height);
    }
  }

  public void update(Graphics g) { paint(g); }

  void Grafo_mouseClicked(MouseEvent e) {
  Grafo g;
  setBorder(BorderFactory.createEtchedBorder(Color.red,new Color(134, 134, 134)));
  if (grafo.p.curr_sel != -1)
    {
     g = (Grafo) grafo.p.m_grafo.get(grafo.p.curr_sel);
     g.getAreaDesenho().setBorder(BorderFactory.createEtchedBorder());
    }
    grafo.p.curr_sel =  grafo.p.m_grafo.indexOf(grafo);
  }

    void Grafo_mousePressed(MouseEvent e) {
    int x = e.getX();
    int y = e.getY();
    no_sel = null;
    for (int i=0; i< grafo.m_listaNos.size(); i++)
    {
    No no = (No) grafo.m_listaNos.get(i);
    if ((Math.abs(no.getX() + 5 - x) < 5) && (Math.abs(no.getY() + 5 - y) < 5)) no_sel = no;
    }
    }

    void Grafo_mouseDragged(MouseEvent e) {
    if (no_sel != null)
    {
    int x = e.getX();
    int y = e.getY();
    no_sel.m_x = x - 5;
    no_sel.m_y = y - 5;
    repaint();
    }
    }

    void Grafo_mouseReleased(MouseEvent e) {
    no_sel = null;
    }

}
