package grafos;

import java.awt.*;
import java.util.*;
import java.awt.event.*;
import javax.swing.*;

public class MainApp extends JFrame{

  // variaveis globais
  ArrayList m_grafo = new ArrayList();
  int next_id = 0, curr_sel = -1;

  // Interface Grfica
  JMenuBar BarraMenu = new JMenuBar();
  JMenu menuFile = new JMenu();
  JMenuItem menuFileExit = new JMenuItem();
  JMenu menuIns = new JMenu();
  JMenuItem menuInsGrafo = new JMenuItem();
  JMenuItem menuInsNo = new JMenuItem();
  JMenuItem menuInsRamo = new JMenuItem();
  JMenu menuRem = new JMenu();
  JMenuItem menuRemGrafo = new JMenuItem();
  JMenu menuHelp = new JMenu();
  JMenuItem menuHelpAbout = new JMenuItem();

  // Metodo principal - primeiro a ser executado
  public static void main(String[] args) {
    try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    new MainApp();
  }

  // construtor de MainApp
  public MainApp() {
    Grafo g;
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    // layout definido
    getContentPane().setLayout(new FlowLayout());

    // inicializa GUI - menus
    InitGUI();

    // chama metodo para criar um grafo exemplo
    m_grafo.add(this.ExemploCriaGrafo());
    // adicionar area do grafo a frame
    g = (Grafo) m_grafo.get(m_grafo.size() - 1);
    getContentPane().add(g.getAreaDesenho());

    // chama metodo para criar um grafo exemplo
    m_grafo.add(this.ExemploCriaGrafo());
    // adicionar area do grafo a frame
    g = (Grafo) m_grafo.get(m_grafo.size() - 1);
    getContentPane().add(g.getAreaDesenho());


    pack();
    show();

    //grava o grafo para um ficheiro de texto
    // m_grafo_1.gravarGrafo("C:\\temp\\teste.txt");
  }

  // constroi os menus
  private void InitGUI()
  {
  menuFile.setText("Ficheiro");
  menuFileExit.setText("Sair");
  menuFileExit.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        // termina a execucao
   	System.exit(0);
      }
  });
  menuIns.setText("Inserir");
  menuInsGrafo.setText("Insere Grafo");
  menuInsGrafo.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        InsGrafo_actionPerformed(e);
      }
  });
  menuInsNo.setText("Insere No");
  menuInsNo.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        InsNo_actionPerformed(e);
      }
  });
  menuInsRamo.setText("Insere Ramo");
  menuInsRamo.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        InsRamo_actionPerformed(e);
      }
  });
  menuRem.setText("Remover");
  menuRemGrafo.setText("Remover Grafo");
  menuRemGrafo.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        RemGrafo_actionPerformed(e);
      }
  });
  menuHelp.setText("Ajuda"); ;
  menuHelpAbout.setText("Acerca");
  menuHelpAbout.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        helpAbout_actionPerformed(e);
      }
  });
  menuFile.add(menuFileExit);
  menuIns.add(menuInsGrafo);
  menuIns.add(menuInsNo);
  menuIns.add(menuInsRamo);
  menuRem.add(menuRemGrafo);
  menuHelp.add(menuHelpAbout);
  BarraMenu.add(menuFile);
  BarraMenu.add(menuIns);
  BarraMenu.add(menuRem);
  BarraMenu.add(menuHelp);
  this.setJMenuBar(BarraMenu);

  }

  private Grafo ExemploCriaGrafo()
  {
    // cria novo objecto grafo
    Grafo g = new Grafo(this, next_id, 200, 200);
    next_id++;

    // Criar 4 nos para teste!!
    g.inserirNo(new No(0, "zero", Color.red, 100, 100, g));
    g.inserirNo(new No(1, "um", Color.blue, 150, 100, g));
    g.inserirNo(new No(2, "dois", Color.orange , 100, 150, g));
    g.inserirNo(new No(3, "tres", Color.green, 50, 50, g));

    // cria 1 ramo
    g.inserirRamo(new Ramo(0,Color.black,false,0, g.encontrarNo(0),g.encontrarNo(1)));
    return g;
  }

  private void ExemploRemoveNos()
  {
    //os ns e ramos so removidos automaticamente sem necessidade de os redesenhar

    // remover No - vamos ficar com apenas 4 Nos
    //    g.removeNo(2);

    // remover No - vamos ficar com apenas 3 Nos
    //    g.removeNo(3);

  }

  // metodo Overridden (substituido) para responder ao fecho da janela
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
    // termina a execucao
   	System.exit(0);
    }
  }

  //Help | About action performed
  public void helpAbout_actionPerformed(ActionEvent e) {
    Frame_AboutBox dlg = new Frame_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.show();
  }

  // remove | Grafo
  void RemGrafo_actionPerformed(ActionEvent e) {
  if (curr_sel != -1)
  {
  Grafo ge = (Grafo) m_grafo.get(curr_sel);
  m_grafo.remove(curr_sel);
  m_grafo.trimToSize();
  getContentPane().remove(ge.getAreaDesenho());
  pack();
  curr_sel --;
  }
  }

  // Insere | Grafo
  void InsGrafo_actionPerformed(ActionEvent e) {
  InsGrafoDialog chooser = new InsGrafoDialog(this, next_id);
  int returnVal = chooser.showDialog();
  if(returnVal == InsGrafoDialog.APPROVE_OPTION)
  {
  m_grafo.add(chooser.getGrafo());
  getContentPane().add(chooser.getGrafo().getAreaDesenho());
  next_id ++;
  pack();
  }
  }

  // Insere | No
  void InsNo_actionPerformed(ActionEvent e) {
  InsNoDialog chooser = new InsNoDialog(this, curr_sel);
  int returnVal = chooser.showDialog();
  if(returnVal == InsNoDialog.APPROVE_OPTION)
  {
  pack();
  }
  }

  // Insere | Ramo
  void InsRamo_actionPerformed(ActionEvent e) {
  InsRamoDialog chooser = new InsRamoDialog(this, curr_sel);
  int returnVal = chooser.showDialog();
  if(returnVal == InsRamoDialog.APPROVE_OPTION)
  {
  pack();
  }
  }

}
