package grafos;

//import de packages necessarias
import java.awt.*;
import java.util.*;

public class Ramo {

    protected int m_idRamo = 0;
    protected Color m_corRamo;
    protected int m_peso = 0;
    protected boolean m_seta = true;
    protected No[] m_ligaNos = new No[2];
    protected Grafo m_ligaGrafo;

//construtor
    public Ramo(int id, Color cor, boolean seta , int peso, No n1,  No n2) {
        m_idRamo=id;
        m_corRamo=cor;
        m_seta=seta;
        m_peso=peso;
        m_ligaNos[0]=n1;
        m_ligaNos[1]=n2;
    }

// obtem os 2 nos ao qual o ramo esta' ligado
    public No[] getNos() {
    return m_ligaNos;
    }

// obtem a id do ramo
    public int getIdRamo() {
    return m_idRamo;
    }

//obtem a cor do ramo
    public Color getCorRamo() {
    return m_corRamo;
    }

// obtem a seta, se for verdadeira  um ramo de um digrafo
// de no[0] para no[1], caso contrario e' simplesmente um ramo
// de um grafo
    public boolean getSeta() {
    return m_seta;
    }
// peso do ramo (em grafos pesados)
    public int peso() {
    return m_peso;
    }

// Desenha o ramo da localizacao do no[0] para a localizacao do no [1]
    public void desenharRamo(Graphics grafico) {
     grafico.setColor(m_corRamo);
     grafico.drawLine(m_ligaNos[0].m_x + 5, m_ligaNos[0].m_y + 5,m_ligaNos[1].m_x + 5,m_ligaNos[1].m_y + 5);
    }

}

